package blanco.plugin.batchprocess.editors;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.URL;

import javax.xml.transform.dom.DOMResult;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.dialogs.IInputValidator;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IFileEditorInput;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import blanco.batchprocess.BlancoBatchProcessConstants;
import blanco.batchprocess.resourcebundle.BlancoBatchProcessResourceBundle;
import blanco.commons.util.BlancoNameUtil;
import blanco.commons.util.BlancoXmlUtil;
import blanco.plugin.batchprocess.BlancoBatchProcessPlugin;
import blanco.plugin.batchprocess.BlancoBatchProcessPluginConstants;
import blanco.plugin.batchprocess.actions.BlancoBatchProcessGenerateAction;

/**
 * エディタ <br>
 * 
 * @author iga
 */
public class BlancoBatchProcessEditor extends AbstractBlancoBatchProcessEditor {
    private static final BlancoBatchProcessResourceBundle fBundle = new BlancoBatchProcessResourceBundle();

    private Composite top = null;

    // ビジュアル領域
    private Label labelBlancoTitle = null;

    private Label labelBlancoSettingId = null;

    private Text textBlancoSettingId = null;

    private Combo comboRuntimePackage = null;

    private Label labelMetadir = null;

    private Text textMetadir = null;

    private Label labelMetadirComment = null;

    private Label labelSettingComment = null;

    private Button buttonExecuteJavaSource = null;

    private Button buttonExecuteCsSource = null;

    private Button buttonCreateMetafile = null;

    public void createPartControl(Composite parent) {
        top = parent;
        top.setSize(new org.eclipse.swt.graphics.Point(1000, 400));

        GridLayout layout = new GridLayout();
        layout.numColumns = 2;
        top.setLayout(layout);

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelBlancoTitle = new Label(top, SWT.NONE);
        labelBlancoTitle.setText(BlancoBatchProcessConstants.PRODUCT_NAME
                + " 設定ファイル エディタ (" + BlancoBatchProcessConstants.VERSION + ")");

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelBlancoSettingId = new Label(top, SWT.NONE);
        labelBlancoSettingId.setText("設定ID");
        textBlancoSettingId = new Text(top, SWT.BORDER);
        textBlancoSettingId.setText(BlancoBatchProcessConstants.PRODUCT_NAME);
        textBlancoSettingId.setEditable(false);

        final Label labelRuntimePackage = new Label(top, SWT.NONE);
        labelRuntimePackage.setText("ランタイムパッケージ");
        createComboRuntimePackage();

        labelMetadir = new Label(top, SWT.NONE);
        labelMetadir.setText("メタディレクトリ");

        textMetadir = new Text(top, SWT.BORDER);
        textMetadir.setText("meta"
                + BlancoBatchProcessConstants.TARGET_SUBDIRECTORY);

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelMetadirComment = new Label(top, SWT.NONE);
        labelMetadirComment.setText("※メタディレクトリは通常変更せずに利用します。");
        labelMetadirComment.setSize(new org.eclipse.swt.graphics.Point(500,
                30 + 20));

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        buttonCreateMetafile = new Button(top, SWT.NONE);
        buttonCreateMetafile
                .setText(fBundle.getMetafileDisplayname() + " 新規作成");
        buttonCreateMetafile
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    public void widgetSelected(
                            org.eclipse.swt.events.SelectionEvent e) {
                        // メタファイル作成の際には、他の項目のチェックは行いません。
                        saveToTextEditor();

                        if (textMetadir.getText().length() == 0) {
                            MessageDialog
                                    .openWarning(
                                            top.getShell(),
                                            fBundle.getMetafileDisplayname()
                                                    + " 新規作成",
                                            "メタディレクトリ名を指定してください。\n"
                                                    + "※メタディレクトリ名の一般的な設定値は 'meta"
                                                    + BlancoBatchProcessConstants.TARGET_SUBDIRECTORY
                                                    + "' です。");
                            return;
                        }

                        final IFileEditorInput input = (IFileEditorInput) getEditorInput();

                        try {
                            if (BlancoBatchProcessPluginUtil.findFolder(
                                    input.getFile(), getProgressMonitor(),
                                    textMetadir.getText()).exists() == false) {
                                BlancoBatchProcessPluginUtil.createFolder(input
                                        .getFile(), getProgressMonitor(),
                                        textMetadir.getText());

                                MessageDialog.openInformation(top.getShell(),
                                        "メタディレクトリの作成", "メタディレクトリ ["
                                                + textMetadir.getText()
                                                + "] を新規に作成しました。\n"
                                                + "※初回にのみ必要な動作です。");
                            }
                        } catch (CoreException e3) {
                            MessageDialog.openWarning(top.getShell(), fBundle
                                    .getMetafileDisplayname()
                                    + " 新規作成", "メタディレクトリ作成に失敗しました。処理中断します。:"
                                    + e3.toString());
                            e3.printStackTrace();
                            return;
                        }

                        InputStream inStream = null;
                        try {
                            final URL localURL = BlancoBatchProcessPlugin
                                    .getPluginRoot();

                            InputDialog inputDialog = new InputDialog(top
                                    .getShell(), fBundle
                                    .getMetafileDisplayname()
                                    + " 新規作成", fBundle.getMetafileDisplayname()
                                    + "をメタディレクトリ[" + textMetadir.getText()
                                    + "]に作成します。"
                                    + fBundle.getMetafileDisplayname()
                                    + "の新規ファイル名を入力してください。",
                                    BlancoBatchProcessConstants.PRODUCT_NAME
                                            + "Meta.xls",
                                    new IInputValidator() {
                                        public String isValid(String newText) {
                                            if (newText.endsWith(".xls") == false) {
                                                return "ファイル名は .xlsで終了するように指定してください。";
                                            }
                                            if (BlancoNameUtil
                                                    .isValidFileName(newText) == false) {
                                                return "ファイル名には "
                                                        + BlancoNameUtil
                                                                .invalidFileNameChar()
                                                        + " は利用しないでください。";
                                            }
                                            // 既にそのファイルが存在しないかどうかをチェック
                                            IFile newFileMeta = input.getFile()
                                                    .getProject().getFolder(
                                                            textMetadir
                                                                    .getText())
                                                    .getFile(newText);
                                            if (newFileMeta.exists()) {
                                                return "指定のファイルは既に存在しています。"
                                                        + "別のファイル名を指定してください。";
                                            }
                                            return null;
                                        }
                                    });
                            if (inputDialog.open() == InputDialog.CANCEL) {
                                inputDialog.close();
                                return;
                            }
                            final String newMetaFilename = inputDialog
                                    .getValue();
                            inputDialog.close();

                            // プラグインのローカルからテンプレートを読み込みます。
                            inStream = new FileInputStream(
                                    localURL.getPath()
                                            + BlancoBatchProcessPluginConstants.TEMPLATE_FILENAME_WITHOUT_EXT
                                            + ".xls");
                            IFile newFileMeta = input.getFile().getProject()
                                    .getFolder(textMetadir.getText()).getFile(
                                            newMetaFilename);
                            newFileMeta.create(inStream, true,
                                    getProgressMonitor());
                            MessageDialog.openInformation(top.getShell(),
                                    fBundle.getMetafileDisplayname() + " 新規作成",
                                    fBundle.getMetafileDisplayname() + " ["
                                            + newMetaFilename + "] をメタディレクトリ["
                                            + textMetadir.getText()
                                            + "]に新規作成しました。\n"
                                            + "このファイルを編集して、関連情報を設定してください。");
                        } catch (CoreException e1) {
                            e1.printStackTrace();
                            return;
                        } catch (IOException e2) {
                            MessageDialog.openWarning(top.getShell(), "メタファイル",
                                    "メタファイルのコピーに失敗しました。:" + e2.toString());
                            e2.printStackTrace();
                        } finally {
                            if (inStream != null) {
                                try {
                                    inStream.close();
                                } catch (IOException e1) {
                                    e1.printStackTrace();
                                }
                            }
                        }

                    }
                });

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        buttonExecuteJavaSource = new Button(top, SWT.NONE);
        buttonExecuteJavaSource.setText("Javaソースコード生成");
        buttonExecuteJavaSource
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    public void widgetSelected(
                            org.eclipse.swt.events.SelectionEvent e) {
                        if (checkInputField() == false) {
                            return;
                        }

                        try {
                            if (checkInputField() == false) {
                                return;
                            }

                            final IFileEditorInput input = (IFileEditorInput) getEditorInput();
                            if (input.getFile().getProject().getFolder(
                                    textMetadir.getText()).exists() == false) {
                                MessageDialog.openWarning(top.getShell(),
                                        "Javaソースコード生成", "メタディレクトリ ("
                                                + textMetadir.getText()
                                                + ") が存在しません。処理を中断します。");
                                return;
                            }

                            showBusy(true);
                            // 再入を防止するために必要です。
                            buttonExecuteJavaSource.setEnabled(false);

                            String runtimePackage = comboRuntimePackage
                                    .getText();
                            if (runtimePackage.trim().length() == 0) {
                                runtimePackage = null;
                            }

                            String metaDir = textMetadir.getText();
                            if (metaDir.trim().length() == 0) {
                                metaDir = null;
                            }

                            BlancoBatchProcessGenerateAction
                                    .processBlancoBatchProcessSource(input
                                            .getFile(), top.getShell(),
                                            getProgressMonitor(), "java",
                                            runtimePackage, metaDir);

                            // blancoフォルダを同期
                            BlancoBatchProcessPluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(), "blanco");

                            // tmpフォルダを同期
                            BlancoBatchProcessPluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(), "tmp");

                            // フォルダを同期
                            // あくまでも保険として同期を取ります。
                            BlancoBatchProcessPluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(),
                                    textMetadir.getText());
                        } catch (Exception ex) {
                            ex.printStackTrace();
                            StringWriter writer = new StringWriter();
                            ex.printStackTrace(new PrintWriter(writer));
                            writer.flush();
                            MessageDialog.openError(top.getShell(),
                                    "Javaソースコード生成", "回復不能なエラーが発生.:"
                                            + ex.toString() + ": "
                                            + writer.toString());
                        } finally {
                            showBusy(false);
                            // 再入を防止するために必要です。
                            buttonExecuteJavaSource.setEnabled(true);
                        }
                    }

                });

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        buttonExecuteCsSource = new Button(top, SWT.NONE);
        // C#.NETソースコード生成は無効化されています！機能未実装です。
        buttonExecuteCsSource.setEnabled(false);
        buttonExecuteCsSource.setText("C#.NETソースコード生成");
        buttonExecuteCsSource
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    public void widgetSelected(
                            org.eclipse.swt.events.SelectionEvent e) {
                        if (checkInputField() == false) {
                            return;
                        }

                        try {
                            if (checkInputField() == false) {
                                return;
                            }

                            final IFileEditorInput input = (IFileEditorInput) getEditorInput();
                            if (input.getFile().getProject().getFolder(
                                    textMetadir.getText()).exists() == false) {
                                MessageDialog.openWarning(top.getShell(),
                                        "C#.NETソースコード生成", "メタディレクトリ ("
                                                + textMetadir.getText()
                                                + ") が存在しません。処理を中断します。");
                                return;
                            }

                            showBusy(true);
                            // 再入を防止するために必要です。
                            buttonExecuteCsSource.setEnabled(false);

                            String runtimePackage = comboRuntimePackage
                                    .getText();
                            if (runtimePackage.trim().length() == 0) {
                                runtimePackage = null;
                            }

                            String metaDir = textMetadir.getText();
                            if (metaDir.trim().length() == 0) {
                                metaDir = null;
                            }
                            BlancoBatchProcessGenerateAction
                                    .processBlancoBatchProcessSource(input
                                            .getFile(), top.getShell(),
                                            getProgressMonitor(), "cs",
                                            runtimePackage, metaDir);

                            // blanco.csフォルダを同期
                            BlancoBatchProcessPluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(),
                                    "blanco.cs");

                            // tmpフォルダを同期
                            BlancoBatchProcessPluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(), "tmp");

                            // フォルダを同期
                            // あくまでも保険として同期を取ります。
                            BlancoBatchProcessPluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(),
                                    textMetadir.getText());
                        } catch (Exception ex) {
                            ex.printStackTrace();
                            StringWriter writer = new StringWriter();
                            ex.printStackTrace(new PrintWriter(writer));
                            writer.flush();
                            MessageDialog.openError(top.getShell(),
                                    "C#.NETソースコード生成", "回復不能なエラーが発生.:"
                                            + ex.toString() + ": "
                                            + writer.toString());
                        } finally {
                            showBusy(false);
                            // 再入を防止するために必要です。
                            buttonExecuteCsSource.setEnabled(true);
                        }
                    }

                });

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelSettingComment = new Label(top, SWT.NONE);
        labelSettingComment.setText("※各々の設定値は "
                + BlancoBatchProcessPluginConstants.TARGET_FILENAME
                + "ファイルに平文で格納されます。");
        labelSettingComment
                .setSize(new org.eclipse.swt.graphics.Point(500, 20));

        loadFromTextEditor();

        setFocusLostHandler(comboRuntimePackage);
        setFocusLostHandler(textMetadir);
    }

    /**
     * 入力項目のチェックを実施します。 <br>
     * エラーダイアログはこのメソッドで表示します。
     * 
     * @return
     */
    private final boolean checkInputField() {
        boolean isError = false;
        if (textMetadir.getText().length() == 0) {
            textMetadir.setBackground(top.getDisplay().getSystemColor(
                    SWT.COLOR_YELLOW));
            isError = true;
        } else {
            textMetadir.setBackground(top.getDisplay().getSystemColor(
                    SWT.COLOR_INFO_BACKGROUND));
        }

        if (isError) {
            MessageDialog.openWarning(top.getShell(), "必須項目への入力が足りません",
                    "必須項目への入力が足りません。\nハイライト表示されている必須項目に値を入力してください");
        }

        return !isError;
    }

    /**
     * ランタイムパッケージコンボを初期化します。
     * 
     */
    private void createComboRuntimePackage() {
        comboRuntimePackage = new Combo(top, SWT.NONE);
        comboRuntimePackage.add("myapp.batchprocess");
    }

    protected void loadFromTextEditorInternal(DOMResult argResult) {
        final Node nodeRoot = argResult.getNode();
        if (nodeRoot == null) {
            return;
        }
        final Element elementBlancoBatchProcess = BlancoXmlUtil.getElement(
                nodeRoot, "blanco/target/"
                        + BlancoBatchProcessConstants.PRODUCT_NAME_LOWER);
        if (elementBlancoBatchProcess == null) {
            return;
        }

        final String runtimePackage = elementBlancoBatchProcess
                .getAttribute("runtimepackage");
        if (runtimePackage != null) {
            comboRuntimePackage.setText(runtimePackage);
        }
        final String metadir = elementBlancoBatchProcess
                .getAttribute("metadir");
        if (metadir != null) {
            textMetadir.setText(metadir);
        }

    }

    /**
     * 保存処理を行います。
     */
    public Document saveToTextEditorInternal() {
        String runtimepackage = null;
        if (comboRuntimePackage.getText().trim().length() > 0) {
            runtimepackage = comboRuntimePackage.getText();
        }

        String metadir = null;
        if (textMetadir.getText().trim().length() > 0) {
            metadir = textMetadir.getText();
        }

        final Document document = BlancoXmlUtil.newDocument();
        final Element eleBlanco = document.createElement("blanco");
        document.appendChild(eleBlanco);

        final Element eleTarget = document.createElement("target");
        eleTarget.setAttribute("name", textBlancoSettingId.getText());
        eleBlanco.appendChild(eleTarget);

        final Element eleBlancoMessage = document
                .createElement(BlancoBatchProcessConstants.PRODUCT_NAME_LOWER);
        eleTarget.appendChild(eleBlancoMessage);

        if (runtimepackage != null) {
            eleBlancoMessage.setAttribute("runtimepackage", runtimepackage);
        }

        if (metadir != null) {
            eleBlancoMessage.setAttribute("metadir", metadir);
        }

        return document;
    }
}